<template>
  <q-page class="q-mx-md" @click="show_list_preview = false">
    <template v-if="data.taxonomy.configuration">
      <div class="row">
        <q-card class="q-ma-md q-pa-md col " flat>
          <q-form>
            <div class="row">
              <q-input label="Local taxonomy dir" v-model="data.taxonomy.configuration.parser.local_taxonomy_dir"
                       class="q-pt-sm col"
                       hint="Locatie waar op schijf taxonomies gevonden kunnen worden. De waarde kan worden gewijzigd in het configuratiebestand van de server"
                       :disable="data.taxonomy.configuration.parser.local_taxonomy_dir > ''"></q-input>
            </div>
            <div class="row">
              <q-select label="NT versie" fill-input v-model="nt_version" class="col"
                        :options="nt_versions" @update:model-value="preview_ep_list"
                        hint="Bij het uploaden van een zipfile wordt de NT versie bepaald tijdens het uitpakken en hoef je hier niets in te vullen "></q-select>
              <q-checkbox label="Alfa" v-model="xbrl_cli.alfa" @click="version_control('alfa')"></q-checkbox>
              <q-checkbox label="Beta" v-model="xbrl_cli.beta" @click="version_control('beta')"></q-checkbox>
              <q-checkbox label="Definitief" v-model="xbrl_cli.final"
                          @click="version_control('final')"></q-checkbox>
            </div>
            <p>&nbsp;</p>
            <q-tabs v-model="tab" class="bg-grey-1">
              <q-tab name="Zip">Upload Zipfile</q-tab>
              <q-tab name="files">Files</q-tab>
            </q-tabs>

            <q-tab-panels v-model="tab" class="bg-grey-1 tab_panel">

              <q-tab-panel name="Zip">
                <q-uploader field-name="zipfile" accept=".zip" id="zipfile" label="Upload zipfile"
                            max-files=1 ref="zipUploader" auto-upload name="zipfiles"
                            :factory="zipFactory"
                            class="full-width bg-grey-1" flat square bordered
                            @uploaded="show_zipcontent"
                            @abort="dummy_abort"
                            :url="otherZipURL">
                </q-uploader>
                <template v-if="zipInfo">
                  <template
                    v-if="(zipInfo.directories && zipInfo.directories.length) || (zipInfo.entrypoints && zipInfo.entrypoints.length)">
                    <q-card-section>
                      <q-btn label="Unpack and add to local store" color="red" class="q-my-md q-px-md"
                             @click="unpack_to_local" :loading="busy"
                             :disable="(zipInfo.zipfiles && zipInfo.zipfiles.length > 0)">
                        <template v-slot:loading>
                          <q-spinner-orbit/>
                        </template>
                      </q-btn>
                      <template v-if="zipInfo.zipfiles && zipInfo.zipfiles.length">
                        <q-card-section>
                          <q-item-label class="text-h5">Zipbestanden in het archief</q-item-label>
                          <p>In dit zipbestand hebben we geen taxonomie aangetroffen. Wel zitten er
                            {{ zipInfo.zipfiles.length }} zipbestand(en) in het bestand.</p>
                          <p>Het advies is om het zipbestand op je computer uit te pakken en met de inhoud het
                            opnieuw te proberen.</p>
                          <q-list dense>
                            <q-item v-for="zip in zipInfo.zipfiles" :key="zip.value">
                              <q-item-section class="list_item">{{ zip.value }}</q-item-section>
                            </q-item>
                          </q-list>
                        </q-card-section>
                      </template>
                      <q-item-label class="text-h5">Inhoud archief</q-item-label>
                      <q-list dense>
                        <q-item v-for="dir of zipInfo.directories" :key="dir.value">
                          <q-item-section class="list_item">
                            {{ dir.label }}
                          </q-item-section>
                        </q-item>
                      </q-list>
                      <template v-if="zipInfo.entrypoints && zipInfo.entrypoints.length">
                        <q-card-section>
                          <q-item-label class="text-h5">gevonden Entrypoints</q-item-label>
                          <q-list dense>
                            <q-item v-for="ep in zipInfo.entrypoints" :key="ep.value">
                              <q-item-section class="list_item">
                                <template v-if="ep.label">
                                {{ ep.label.split("/").at(-1) }}
                                  </template>
                                <template v-else>
                                  {{ ep.name }}
                                </template>
                              </q-item-section>
                            </q-item>
                          </q-list>
                        </q-card-section>
                      </template>
                    </q-card-section>
                  </template>
                  <template v-else-if="zipInfo.zipfiles && zipInfo.zipfiles.length">
                    <q-card-section>
                      <q-item-label class="text-h5">Zipbestanden in het archief</q-item-label>
                      <p>In dit zipbestand hebben we geen taxonomie aangetroffen. Wel zitten er
                        {{ zipInfo.zipfiles.length }} zipbestand(en) in het bestand.</p>
                      <p>Het advies is om het zipbestand op je computer uit te pakken en met de inhoud het
                        opnieuw te proberen.</p>
                      <q-list dense>
                        <q-item v-for="zip in zipInfo.zipfiles" :key="zip.value">
                          <q-item-section class="list_item">{{ zip.value }}</q-item-section>
                        </q-item>
                      </q-list>

                    </q-card-section>
                  </template>

                </template>
              </q-tab-panel>

              <q-tab-panel name="files">
                <div class="q-mt-md row">
                  <div class="col q-ml-md">aanwezige entrypoints:</div>
                  <q-checkbox v-model="toggle_all" :label="!toggle_all ? 'Selecteer alles': 'Deselecteer alles'"
                              dense class="select_all col" @update:model-value="select_all()"></q-checkbox>
                </div>
                <div class="q-mx-md q-mt-sm q-px-md filelist">
                  <q-option-group v-model="parse_list" type="checkbox" :options="ep_options_list" dense>
                  </q-option-group>
                </div>
              </q-tab-panel>

              <!--              <q-tab-panel name="taxonomy_package">-->
              <!--                <q-uploader field-name="tax_package" accept=".zip" id="tax_package" label="Upload taxonomy package"-->
              <!--                            max-files=1 ref="fileUploader" auto-upload name="tax_package"-->
              <!--                            :factory="zipFactory"-->
              <!--                            @uploaded="show_taxonomyPackage_response"-->
              <!--                            @failed="package_fail"-->
              <!--                            :url="taxonomyPackageURL"-->
              <!--                            class="full-width bg-grey-1" flat square bordered-->
              <!--                            @abort="dummy_abort"-->
              <!--                ></q-uploader>-->
              <!--                <q-card class="q-ma-sm full-width bg-grey-1" flat>-->
              <!--                  <p>We verwachten hier een zipfile in <a-->
              <!--                    href="https://www.xbrl.org/Specification/taxonomy-package/PR-2015-12-09/taxonomy-package-PR-2015-12-09.html#taxonomy-package">het-->
              <!--                    taxonomy package formaat</a>.<br/>-->
              <!--                    Het is mogelijk dat er een extra archief is gemaakt van een of meerdere-->
              <!--                    taxonomy-packages. In dat geval moet je die lokaal uitpakken en dan uploaden</p>-->
              <!--                </q-card>-->
              <!--                <q-input v-if="xbrl_cli.taxonomy_package" v-model="xbrl_cli.taxonomy_package" clearable-->
              <!--                         hint="Om met bestanden ipv dit taxonomy-package te werken moet u deze waarde verwijderen."-->
              <!--                         @clear="xbrl_cli.has_taxonomy_package=false">-->
              <!--                </q-input>-->
              <!--              </q-tab-panel>-->

            </q-tab-panels>
            <div class="row">
              <div class="col">
                <q-checkbox label="Parse" v-model="xbrl_cli.parse" disable></q-checkbox>
              </div>
              <div class="col">
                <q-checkbox label="Valideer" v-model="xbrl_cli.validate_nt" @click="btn_control()"></q-checkbox>
              </div>
              <div class="col">
                <q-checkbox label="Opslaan in DB" v-model="xbrl_cli.store" @click="btn_control()"></q-checkbox>
              </div>
            </div>
            <div class="row q-mt-sm">
              <div class="col">
                <q-checkbox label="Vergelijk met oude versie(s) " v-model="xbrl_cli.compare" @click="btn_control()">
                </q-checkbox>
              </div>
              <div class="col">
                <q-select v-model="xbrl_cli.run_id" :options="run_ids" label="Run ID" color="black" bg-color="white"
                          outlined :disable="! xbrl_cli.compare">
                </q-select>
              </div>
            </div>
            <div>
              <q-input name="notify" label="E-mailadres" v-model="xbrl_cli.notify" type="email" class="q-mx-sm"
                       hint="Wanneer alles klaar is sturen we een e-mail naar dit adres (optioneel)"></q-input>
            </div>
            <div class="row">
              <div class="col">
                <q-btn :label="btn_label" @click="submit_load" color="red" class="q-mt-md q-pl-md"
                       :disable="!parse_available"></q-btn>
              </div>
            </div>
          </q-form>
        </q-card>
        <ParseConfiguration :configuration="data.taxonomy.configuration" :xbrl_cli="xbrl_cli"
                            :parse_list="parse_list"></ParseConfiguration>

      </div>
    </template>

    <q-card v-if="show_list_preview" class="help_card" @click.stop>
      <div style="position: relative">
        <q-toolbar-title class="fix_me">
          <div class="list_close q-my-sm">
            <q-icon name="close" @click="show_list_preview = false" class="cursor-pointer"/>
          </div>
        </q-toolbar-title>
        <div class="q-pt-xl"></div>
        <div :key="index" v-for="(line, index) of ep_list_array" class="q-px-md">{{ line }}</div>
      </div>
    </q-card>

    <q-banner v-if="upload_error" class="upload_error_banner text-white bg-red absolute-top q-mt-xl shadow-3">
      De volgende fout is opgetreden:
      <div class="text-bold">{{ last_error }}</div>
      <template v-slot:action>
        <q-btn flat label="Dismiss" @click="upload_error = false" @keydown.esc="upload_error = false"/>
      </template>
    </q-banner>

    <q-banner v-if="upload_warning" class="upload_warning_banner text-black bg-yellow-11 absolute-top q-mt-xl shadow-3">
      Bij het lezen van het taxonomy-package
      <div v-for="warning in last_warnings" :key="warning" class="text-bold">{{ warning }}</div>
      <template v-slot:action>
        <q-btn flat label="Dismiss" @click="upload_warning = false" @keydown.esc="upload_warning = false"/>
      </template>
    </q-banner>

  </q-page>
</template>

<script>
import {api} from "boot/axios";
import ParseConfiguration from "components/ParseConfiguration";
import {Cookies} from 'quasar'
import {useStore} from 'vuex'

export default {
  name: "DashboardDetail",
  components: {ParseConfiguration},
  created() {
    this.fetchData()
    this.get_local_nt_versions()
  },
  data() {
    return {
      data: {taxonomy: Object},
      ep_list: undefined,
      ep_list_array: [],
      xbrl_cli: {
        parse: true,
        store: true,
        validate_nt: true,
        compare: true,
        run_id: "",
        build_ep_list: false,
        alfa: false,
        beta: false,
        final: true,
        nt_version: "",
        taxonomy_package: "",
        notify: "",
        ep_list: [],
      },
      show_list_preview: false,
      nt_versions: [],
      nt_version: "",
      parse_list: [],
      ep_options_list: [],
      run_ids: ["SBR", "KVK", "BD", "BZK", "OCW"],
      tab: 'Zip',
      toggle_all: false,
      upload_error: false,
      upload_warning: false,
      last_error: undefined,
      last_warnings: [],
      btn_label: "Parse",
      url: "",
      busy: false,
      zipInfo: undefined,
    }
  },
  computed: {
    otherZipURL() {
      return api.defaults.baseURL + "/admin/upload_zip"
    },
    taxonomyPackageURL() {
      return api.defaults.baseURL + "/admin/upload_taxonomy_package"
    },
    parse_available() {
      let parse_available = false
      if (this.xbrl_cli.taxonomy_package > '' || this.xbrl_cli.ep_list.length > 0
        || (this.xbrl_cli.nt_version > '' && this.parse_list.length > 0)) {
        parse_available = true
      }
      return parse_available
    }
  },
  methods: {
    fetchData: function () {
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .get("/admin/taxonomy", {headers})
        .then(response => {
          this.data.taxonomy = response.data
          // use the email address from the configuration if none is provided thusfar ...
          if (this.data.taxonomy.configuration.parser.notify && !this.xbrl_cli.notify) {
            this.xbrl_cli.notify = this.data.taxonomy.configuration.parser.notify
          }
          // if the current Nessie admin user has en email address, use that one
          if (this.$store.state.user.User.email) {
            this.xbrl_cli.notify = this.$store.state.user.User.email
          }
          this.get_local_nt_versions()
        })
        .catch((error) => {
          if (error.response.status == 401) {
            this.$store.commit('user/LOGOUT', '')
            if (Cookies.has('kc_token')) {
              Cookies.remove('kc_token')
            }
            this.$store.commit('user/LOGIN_ERROR', 'Sessie verlopen, log opnieuw in')
          }
        })
    },
    preview_ep_list: function (_callback = undefined) {
      if (this.nt_version) {
        this.xbrl_cli.nt_version = this.nt_version
      }
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .post("/admin/preview_ep_list", this.xbrl_cli, {headers})
        .then(response => {
          this.ep_list_array = response.data
          this.ep_options_list = []
          if (this.url) {
            this.parse_list = [this.url]
          } else {
            this.parse_list = []
          }
          response.data.forEach((ep) => {
            let label = ep.replace(this.data.taxonomy.configuration.parser.local_taxonomy_dir, '')
              .replaceAll('/', ' ')
            let parts = label.trim().split(' ')
            this.ep_options_list.push(
              {
                label: parts[4],
                value: ep
              }
            )
          })
          if (_callback && typeof _callback === 'function') {
            _callback()
          }
        })
    },
    get_local_nt_versions: function () {
      if (this.data
        && this.data.taxonomy.configuration
        && this.data.taxonomy.configuration.parser.local_taxonomy_dir) {
        let headers = {}
        if (this.$store.state.user.token) {
          headers = {"Authorization": "Bearer " + this.$store.state.user.token}
        }

        api
          .get("/admin/available_nt_versions",
            {headers, params: {local_taxonomy_dir: this.data.taxonomy.configuration.parser.local_taxonomy_dir}})
          .then(response => {
            this.nt_versions = response.data.nt_versions
          })
      }
    },
    btn_control: function () {
      let actions = ["Parse"]
      const formatter = new Intl.ListFormat("nl", {style: "long", type: "conjunction"})
      if (this.xbrl_cli.validate_nt) {
        actions.push("valideer")
      }
      if (this.xbrl_cli.store) {
        actions.push("opslaan")
      }
      if (this.xbrl_cli.compare) {
        actions.push("vergelijk")
      }
      this.btn_label = formatter.format(actions)
    },
    version_control: function (clicked) {
      switch (clicked) {
        case 'alfa':
          if (this.xbrl_cli.alfa) {
            this.xbrl_cli.beta = false
            this.xbrl_cli.final = false
          }
          break;
        case 'beta':
          if (this.xbrl_cli.beta) {
            this.xbrl_cli.alfa = false
            this.xbrl_cli.final = false
          }
          break;
        case 'final':
          if (this.xbrl_cli.final) {
            this.xbrl_cli.alfa = false
            this.xbrl_cli.beta = false
          }
      }
      this.preview_ep_list()
      this.toggle_all = false
    },
    select_all: function () {
      this.parse_list = []
      if (this.toggle_all) {
        this.ep_list_array.forEach(ep => {
          this.parse_list.push(ep)
        })
      }
    },
    unpack_to_local: function () {
      this.busy = true
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .post("/admin/unpack_to_local", {
          "conf": this.data.taxonomy,
          "cli": this.xbrl_cli,
          "zipfiles": this.parse_list,
          "local_taxonomy_dir": this.data.taxonomy.configuration.parser.local_taxonomy_dir,
        }, {headers})
        .then(response => {
          this.busy = false
          this.zipInfo = response.data
          if (this.zipInfo.nt_version) {
            this.nt_version = this.zipInfo.nt_version
            this.xbrl_cli.nt_version = this.nt_version
          }
          if (this.zipInfo.sub_version && this.zipInfo.sub_version === 'alfa') {
            this.xbrl_cli.alfa = true
            this.xbrl_cli.beta = false
            this.xbrl_cli.final = false
          }
          if (this.zipInfo.sub_version && this.zipInfo.sub_version === 'beta') {
            this.xbrl_cli.beta = true
            this.xbrl_cli.alfa = false
            this.xbrl_cli.final = false
          }
          if (this.zipInfo.entrypoints.length > 0) {
            this.tab = 'files'
            this.preview_ep_list(() => {
              this.zipInfo.entrypoints.forEach(ep => {
                this.parse_list.push(ep.value)
              })
            })
          }
        })
    },
    submit_load: function () {
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      api
        .post("/admin/load_tax", {
          "conf": this.data.taxonomy,
          "cli": this.xbrl_cli,
          "ep_list": this.parse_list
        }, {headers})
      this.$router.push({path: this.$route.fullPath, query: {pos: 0}})
    },
    zipFactory: function (file) {
      if (this.$store.state.user.token) {
        return new Promise((resolve, reject) => {
          resolve({
            method: 'POST',
            headers: [{name: "Authorization", value: "Bearer " + this.$store.state.user.token}],
            fieldName: "zipfiles",
            responseType: 'json'
          })
        })
      }
    },
    show_zipcontent(info) {
      this.zipInfo = JSON.parse(info.xhr.responseText)
      this.parse_list = [this.zipInfo.filename]
    },
    show_taxonomyPackage_response(info) {
      let response = JSON.parse(info.xhr.responseText)
      this.xbrl_cli.taxonomy_package = response.filename
      if (response.messages) {
        this.upload_warning = true
        this.last_warnings = response.messages
      }
    },
    package_fail(info) {
      let response = JSON.parse(info.xhr.responseText)
      this.upload_error = true
      this.last_error = response.detail.error
    },
    dummy_abort: function (file) {
      return true
    },
  }
}
</script>

<style scoped lang="scss">
.filelist {
  min-height: 5vh;
  max-height: 50vh;
  overflow-y: auto;
  border: 1px inset $primary;
}

.tab_panel {
  min-height: 300px;
}

.select_all {
  float: right;
}

.fix_me {
  width: 73%;
  background-color: white;
  position: fixed;
}

.list_close {
  float: right;
}

.help_card {
  font-size: 14px;
}

.upload_error_banner {
  max-width: 400px;
  margin: 0 auto;
}

.upload_warning_banner {
  max-width: 400px;
  margin: 0 auto;
}
</style>
